searchNodes=[{"doc":"","ref":"ChannelHandler.html","title":"ChannelHandler","type":"module"},{"doc":"","ref":"ChannelHandler.Context.html","title":"ChannelHandler.Context","type":"module"},{"doc":"Puts a value in the context bindings. If the key is already present in the bindings, the value is overwritten. Examples iex&gt; context = % Context { bindings : %{ foo : 1 } } iex&gt; assign ( context , :foo , 2 ) % Context { bindings : %{ foo : 2 } } iex&gt; assign ( context , :bar , 2 ) % Context { bindings : %{ foo : 1 , bar : 2 } }","ref":"ChannelHandler.Context.html#assign/3","title":"ChannelHandler.Context.assign/3","type":"function"},{"doc":"Assigns a new value to the context bindings. If the key is already present in the bindings, the context is returned. Examples iex&gt; context = % Context { bindings : %{ foo : 1 } } iex&gt; assign_new ( context , :foo , fn -&gt; 2 end ) % Context { bindings : %{ foo : 1 } } iex&gt; assign_new ( context , :bar , fn -&gt; 2 end ) % Context { bindings : %{ foo : 1 , bar : 2 } }","ref":"ChannelHandler.Context.html#assign_new/3","title":"ChannelHandler.Context.assign_new/3","type":"function"},{"doc":"","ref":"ChannelHandler.Context.html#t:t/0","title":"ChannelHandler.Context.t/0","type":"type"},{"doc":"Index join router plug event delegate handle scope plug event delegate handle Docs join :channel ( String.t/0 ) - The channel path for this handler. By default this has no runtime effect, but can be used by plugs and handlers if necessary. The channel value is stored in the socket's :__channel__ assign. :join (function of arity 3) - The function to run in the channel's join callback. router Defines the handle_in/3 functions for a Phoenix channel by matching on exact event names, or prefixes. Example # Adds a module plug to the list of plugs to be run before each event plug MyApp.ChannelPlugs.EnsureAuthenticated # Delegate all events starting with `&quot;foo:&quot;` to the `FooHandler` module delegate &quot;foo:&quot; , FooHandler # Delegates `&quot;create&quot;` events to the `FooHandler.create/3` function event &quot;create&quot; , FooHandler , :create # Defines an inline handler handle &quot;delete&quot; , fn payload , context , socket -&gt; result delete_post ( payload ) { :reply , result , socket } end # Defines a scope, which is useful to add plugs for a specific scope of # events scope &quot;comments:&quot; do # Adds a capture function as a plug to be run before each event in the scope plug &amp; check_permission / 4 , :comment event &quot;create&quot; , CommentsHandler , :create end plug event delegate handle scope plug event delegate handle plug Registers a plug for the current router/scope. Plugs are run in the order they are defined before the event handler. An optional argument can be passed as the options for the plug. :plug - Required. :options ( term/0 ) - event :name ( String.t/0 ) - Required. :module ( atom/0 ) - Required. :function ( atom/0 ) - Required. delegate Defines a handler that delegates all events matching the prefix to the specified module 's ChannelHandler.Handler.handle_in/4 callback. Example delegate &quot;posts:&quot; , PostsHandler defmodule PostsHandler do def handle_in ( &quot;create&quot; , payload , _context , socket ) do post = Posts . create ( payload ) { :reply , { :ok , post } , socket } end end :prefix ( String.t/0 ) - Required. :module ( atom/0 ) - Required. handle Defines a handler for the event . function must be an arity 3 function taking the payload, context and socket.any() Example handle &quot;create&quot; , fn payload , _context , socket -&gt; post = create_post ( payload ) { :reply , post } end :name ( String.t/0 ) - Required. :function - Required. scope plug event delegate handle :prefix ( String.t/0 ) - plug Registers a plug for the current router/scope. Plugs are run in the order they are defined before the event handler. An optional argument can be passed as the options for the plug. :plug - Required. :options ( term/0 ) - event :name ( String.t/0 ) - Required. :module ( atom/0 ) - Required. :function ( atom/0 ) - Required. delegate Defines a handler that delegates all events matching the prefix to the specified module 's ChannelHandler.Handler.handle_in/4 callback. Example delegate &quot;posts:&quot; , PostsHandler defmodule PostsHandler do def handle_in ( &quot;create&quot; , payload , _context , socket ) do post = Posts . create ( payload ) { :reply , { :ok , post } , socket } end end :prefix ( String.t/0 ) - Required. :module ( atom/0 ) - Required. handle Defines a handler for the event . function must be an arity 3 function taking the payload, context and socket.any() Example handle &quot;create&quot; , fn payload , _context , socket -&gt; post = create_post ( payload ) { :reply , post } end :name ( String.t/0 ) - Required. :function - Required.","ref":"ChannelHandler.Dsl.html","title":"ChannelHandler.Dsl","type":"module"},{"doc":"A module implementing an event handler. You can use ChannelHandler.Handler to import phoenix functions like push or reply, and the plug macro for handler-level plugs.","ref":"ChannelHandler.Handler.html","title":"ChannelHandler.Handler","type":"behaviour"},{"doc":"Hanndles a delegated event. This function is called when using delegate in a router. defmodule MyRouter do use ChannelHandler.Router delegate &quot;posts:&quot; , PostsHandler end defmodule PostsHandler do use ChannelHandler.Handler def handle_in ( &quot;create&quot; , payload , context , socket ) do # ... end end","ref":"ChannelHandler.Handler.html#c:handle_in/4","title":"ChannelHandler.Handler.handle_in/4","type":"callback"},{"doc":"Registers a plug for the current module. defmodule MyHandler do use ChannelHandler.Handler plug &amp; check_permissions / 4 , [ :create ] def create ( _payload , context , socket ) do # Authorized users only end def check_permissions ( socket , payload , context , opts ) do permissions = opts [ :permissions ] || [ ] user_permissions = socket . assigns . current_user . permissions if Enum . any? ( permissions , &amp; Enum . member? ( user_permissions , &amp;1 ) ) do { :cont , socket , payload , context } else { :reply , { :error , &quot;Unauthorized&quot; } , socket } end end end Plugs support guards, and can be used to filter events or actions. plug &amp; do_something / 4 when action in [ :create , :update ] Due to operator precedence in Elixir, if the second argument is a keyword list, we need to wrap the keyword in [...] when using when : plug &amp; authenticate / 4 , [ usernames : [ &quot;jose&quot; , &quot;eric&quot; , &quot;sonny&quot; ] ] when action in [ :create , :update ] plug &amp; authenticate / 4 , [ usernames : [ &quot;admin&quot; ] ] when not action in [ :create ] The first plug will run when the action is :create or :update . The second will always run except when the action is :create . Those guards work like regular Elixir guards and the only variables accessible in the guard are the action as an atom and the event as a string.","ref":"ChannelHandler.Handler.html#plug/1","title":"ChannelHandler.Handler.plug/1","type":"macro"},{"doc":"Defines a module plug. For more information about plugs, check plug/1 .","ref":"ChannelHandler.Handler.html#plug/2","title":"ChannelHandler.Handler.plug/2","type":"macro"},{"doc":"A ChannelHandler.Plug , is a function or module that takes the connection socket, the payload and the current handler bindings, and either returns a modified version of each, or directly replies to the client, halting further processing. The plug can either be a module implementing the ChannelHandler.Plug behaviour, or an function of arity 4 Examples def call ( socket , _payload , _bindings , _opts ) do case authenticated? ( socket ) do { :cont , socket , payload , bindings } else { :reply , { :error , &quot;Not authenticated&quot; } , socket } end end","ref":"ChannelHandler.Plug.html","title":"ChannelHandler.Plug","type":"behaviour"},{"doc":"","ref":"ChannelHandler.Plug.html#c:call/4","title":"ChannelHandler.Plug.call/4","type":"callback"},{"doc":"For documentation about the router, check ChannelHandler.Dsl . To add a router to your Channel, do use ChannelHandler.Router # Your events here","ref":"ChannelHandler.Router.html","title":"ChannelHandler.Router","type":"module"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"Helpers to organize and route messages in complex Phoenix channels.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add the following to your mix.exs dependencies: { :channel_handler , &quot;~&gt; 0.5&quot; }","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"After defining a channel with vanilla Phoenix's channel : channel &quot;post:*&quot; , MyAppWeb.PostChannel Define your channel handler, and add use ChannelHandler.Router in addition to the use MyAppWeb, :channel : defmodule MyAppWeb.PostChannel do use MyAppWeb , :channel use ChannelHandler.Router end Now you can start defining matchers and event handlers: defmodule MyAppWeb.PostChannel do use MyAppWeb , :channel use ChannelHandler.Router join fn _topic , _payload , socket -&gt; { :ok , socket } end plug MyAppWeb.ChannelPlugs.EnsureAuthenticated event &quot;comments:create&quot; , MyAppWeb.PostCommentsHandler , :create delegate &quot;comments:&quot; , MyAppWeb.PostCommentsHandler handle &quot;post:create&quot; , fn payload , _bindings , socket -&gt; case MyApp.Posts . create ( payload ) do { :ok , post } -&gt; { :reply , { :ok , post } , socket } { :error , reason } -&gt; { :reply , { :error , reason } , socket } end end scope &quot;secret:&quot; do plug &amp; check_permission / 4 , :do_secret_stuff # You can use splat patterns to match anything with * event &quot;foo:*&quot; , SuperSecretHandler , :foo # Not specifying a prefix matches everything delegate SuperSecretHandler end def check_permission ( socket , _payload , _bindings , permission ) do if MyApp.Authorization . can? ( socket . assigns . current_user , permission ) do # using :cont resumes the event handling { :cont , socket , payload , bindings } else # returning :reply or :noreply halts the event handling { :reply , { :error , &quot;Unauthorized&quot; } , socket } end end end defmodule MyAppWeb.PostCommentsHandler do use ChannelHandler.Handler # Add a plug only for the create action plug MyAppWeb.ChannelPlugs.CheckPermission , :comment_posts when action in [ :create ] def handle_in ( event , payload , bindings , socket ) do # Do something with the delegated event end def create ( payload , bindings , socket ) do # Create a comment end end For more explanations about the API functions and what's possible, check the docs for ChannelHandler.Dsl .","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Copyright (c) 2023 dorgandash@gmail.com Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]